
from ATOM3 import ATOM3


import exporter_ClassDiagram 
import exporter_FileOutputer
import exporter_StateChartDiagram

reload(exporter_ClassDiagram)
reload(exporter_FileOutputer)
reload(exporter_StateChartDiagram)

def export(existingATOM3, model):
    
    classes = []
    classesNames = ""
        
    for classEntity in model.listNodes['CD_Class3']:
        c = exporter_ClassDiagram.ClassDiagram(classEntity, existingATOM3)
        print "Class", c.name, "has been loaded in exporter."
        classesNames = classesNames + " " + c.name
        classes.append(c)
    
    #baseClass = exporter_ClassDiagram.ClassDiagram()
    #baseClass.name = "Atom3CDST"
    #baseClass.objectRef.append(("chartEventList", "list<char *>"))
    #baseClass.methods.append( ("GEN", "Atom3CDST * target, char* const event", "void", 
    #                           "char * newEvent = new char[strlen(event)+1]; \n" + 
    #                           "strcpy(newEvent, event); \n" +
    #                           "target->chartEventList.push_back(newEvent); \n") )
    #    
    #classes.append(baseClass)
            
    for c in classes:
        exporter = CPPExporter(c)
        exporter.run()

    return classesNames

class CPPExporter:

    def __init__(self, classDiagram):
        
        self.classDiagram = classDiagram
        self.attributeInit = ""
        if classDiagram.stateChart == 0:
            self.stateChart = None
        else:
            self.stateChart = classDiagram.stateChart 
        
    def run(self):
    
        self.fOut = exporter_FileOutputer.FileOutputer(self.classDiagram.name + ".cpp")
        self.fHeader = exporter_FileOutputer.FileOutputer(self.classDiagram.name + ".h")
        
        #self.fOut = exporter_FileOutputer.FileOutputer("D:\\dev\\tankwars\\src\\Arena\\" + self.classDiagram.name + ".cpp")
        #self.fHeader = exporter_FileOutputer.FileOutputer("D:\\dev\\tankwars\\src\\Arena\\" + self.classDiagram.name + ".h")
        
        self.fOut.write("#include \"" + self.classDiagram.name + ".h\"")
        
        self.fHeader.write("#ifndef ATOM3_"+self.classDiagram.name+"__H")
        self.fHeader.write("#define ATOM3_"+self.classDiagram.name+"__H")
        self.fHeader.write()
        
        self.fHeader.write("#define INFINITY -1")                                                          
        self.fHeader.write("#include <time.h>")
        self.fHeader.write("#include <sys/timeb.h>")
        self.fHeader.write("#include <string>")
        self.fHeader.write("#include <list>")
        
        self.fHeader.write("#include \"Atom3CDST.h\"")
                                                          
        self.fHeader.write("using namespace std;")
        self.fHeader.write()
    
        #self.fHeader.write("typedef list<my" + self.classDiagram.name + "Event> EventList;")
        #self.fHeader.write()
        
        self.fOut.write()
        for code in self.classDiagram.preClassCode:
            self.writeHeader(code)
        self.fOut.write()
        
        if self.stateChart != None:
            self.fHeader.write("class " + self.classDiagram.name + ": public Atom3CDST {")
        else:
            self.fHeader.write("class " + self.classDiagram.name + " {")
        
        self.fHeader.indent()
        self.fHeader.write()
        
        self.fHeader.write("public:")
        self.fHeader.indent()
        
                
        for attribute, type, initValue in self.classDiagram.attributes:
            if type == "Float" :
                self.fHeader.write("float " + attribute + ";")
            if type == "Integer" :
                self.fHeader.write("int " + attribute + ";")
            if type == "Boolean" :                
                self.fHeader.write("bool " + attribute + ";")
            self.attributeInit += attribute + " = " + initValue + "; \n"      
    
        self.fHeader.write()
                                                          
        for name, type in self.classDiagram.objectRef:
            self.fHeader.write(type + " " + name + ";")
    
        self.fHeader.write()
                                                          
        if self.stateChart != None:
                        
            self.fHeader.write("enum my" + self.classDiagram.name + "State {")
            self.fHeader.indent()
            
            for state in self.stateChart.basics:
                self.fHeader.write(state.name.getValue() + ",")
                            
            self.fHeader.write("NONE")
            self.fHeader.dedent()        
            self.fHeader.write("};")
            self.fHeader.write()
                                
            self.fHeader.write("my" + self.classDiagram.name + "State currentState;")        
            self.fHeader.write("long currentTime;")
            
            if self.stateChart.numberTimeTransitions != 0:
                self.fHeader.write("long timers[" + str(self.stateChart.numberTimeTransitions) + "];")
                   
            self.initCodeForChart(self.classDiagram.constructors)
            self.fOut.write()            
            self.fHeader.write("void process( );")    
            self.fHeader.write()
            
        else:
            for parameters, body in self.classDiagram.constructors:
                self.writeMethod(self.classDiagram.name, parameters, "", self.attributeInit + body)
        
        for name, parameters, returnType, body in self.classDiagram.methods:
            self.writeMethod(name, parameters, returnType, body)  
                                
        for body in self.classDiagram.destructors:
            self.writeMethod("~" + self.classDiagram.name, "", "", body)  
            
        self.fHeader.dedent()         
        self.fHeader.dedent() 
        self.fHeader.write("};")
        self.fHeader.write()
        self.fHeader.write("#endif")
            
        if self.stateChart != None:
            self.processChart()
            
        self.fHeader.close()
        self.fOut.close()    

    def writeHeader(self, body):
        
        lineByLine = body.split("\n")
        for line in lineByLine:
            self.fHeader.write(line)
    
    def writeCode(self, body):
        
        lineByLine = body.split("\n")
        for line in lineByLine:
            self.fOut.write(line)
            
    def writeConstructor(self, name, parameters, body):
        
        self.fHeader.write( name + "( " + parameters + " );")
        
        self.fOut.write()    
        self.fOut.write(self.classDiagram.name + "::" + name + "( " + parameters + " ) {\n")
        self.fOut.indent()
        self.fOut.write()
                
        self.writeCode(body)
        self.fOut.write()
        
        self.fOut.write("timeb temp;")
        self.fOut.write("ftime(&temp);")
        self.fOut.write("currentTime = temp.time * 1000 + temp.millitm;")        
        self.fOut.write("currentState = " + self.stateChart.initState +";")                
        self.fOut.write()
        if self.stateChart.numberTimeTransitions != 0:
            for i in range(0, self.stateChart.numberTimeTransitions):
                self.fOut.write("timers["+str(i)+"] = INFINITY;")
            for timer, exp in self.stateChart.initTimers:
                self.fOut.write("timers["+timer+"] = " + exp + " + currentTime;")            
            self.fOut.write()
            
        for code in self.stateChart.initCode:
            self.writeCode(code)

        self.fOut.dedent()
        self.fOut.write("}")
    
    def writeMethod(self, name, parameters, returnType, body):
        
        self.fHeader.write( returnType + " " + name + "( " + parameters + " );")
        
        self.fOut.write(returnType + " " + self.classDiagram.name 
                        + "::" + name + "( " + parameters + " ) {\n")
        self.fOut.indent()
        self.fOut.write()
        self.writeCode(body)
        self.fOut.write()
        self.fOut.dedent()
        self.fOut.write("}\n\n")
    
    def initCodeForChart(self, constructors):
        
        if constructors != []:
            for parameters, body in constructors:
                self.writeConstructor(self.classDiagram.name, parameters, self.attributeInit + body)    
        else:
            self.writeConstructor(self.classDiagram.name, "", self.attributeInit)  
            
        
    def processChart(self):
        
        self.fOut.write("void " + self.classDiagram.name + "::process() {\n")
        self.fOut.indent()
        self.fOut.write("char event_id[32];")
        self.fOut.write("char event_message[40];")
        self.fOut.write("timeb temp;")
        self.fOut.write("ftime(&temp);")
        self.fOut.write("currentTime = temp.time * 1000 + temp.millitm;")
        if self.stateChart.numberTimeTransitions != 0:
            self.fOut.write("// Lets check the timers")
            self.fOut.write("for (int i = 0; i < " + str(self.stateChart.numberTimeTransitions) + "; i++) {")
            self.fOut.indent()
            self.fOut.write("if ((timers[i] != INFINITY) && (timers[i] < currentTime)) {")
            self.fOut.indent()
            self.fOut.write("itoa(i, event_id, 32);")
            self.fOut.write("event_message[0] = 0;")
            self.fOut.write("strcat(event_message, \"_\");")
            self.fOut.write("strcat(event_message, event_id);")
            self.fOut.write("strcat(event_message, \"after\");")                        
            self.fOut.write("GEN(this, event_message);")
            self.fOut.dedent()
            self.fOut.write("}")
            self.fOut.dedent()
            self.fOut.write("}")
    
        self.fOut.write()        
        self.fOut.write("while(chartEventList.size() != 0) {")
        self.fOut.indent()
        self.fOut.write()
        self.fOut.write("char* event = chartEventList.front();")
        self.fOut.write("chartEventList.pop_front();")
        self.fOut.write()
        for state in self.stateChart.basics:
            # If the state has transition
            if self.stateChart.transitionData[state] != [] :            
                self.fOut.write("if ( currentState == " + state.name.getValue() + " ) {\n")
                self.fOut.indent()
                self.processTransition(state)
                self.fOut.dedent()
                self.fOut.write("}")
        
        self.fOut.write("delete(event);")
        self.fOut.dedent()
        self.fOut.write("}")
            
        self.fOut.dedent()
        self.fOut.write("}\n")
        
    def processTransition(self, state):
        
        transitions = self.stateChart.transitionData[state]
        
        for transition in transitions:
                                        
            if "event" in transition:
                condition = "( strcmp(event, \"" + transition["event"] + "\") == 0 )"
            else:
                condition = ""
            
            if "guard" in transition:
                if transition["guard"] == "1":
                    transition["guard"] = "true"
                        
                if condition == "":
                    condition = transition["guard"]
                else :
                    condition += " && (" + transition["guard"] + ")"
            
            self.fOut.write()
            self.fOut.write("if ( " + condition + " ) {")
            self.fOut.indent()
            
            for key, value in transition["timersToReset"]:
                self.fOut.write("timers[" + key + "] = INFINITY;")
                
            for key, value in transition["historyToSet"]:
                self.fOut.write("history[" + key + "] = " + value)
                
            for key, value in transition["timersToSet"]:
                self.fOut.write("timers[" + key + "] = " + value + " + currentTime;")
            
            for code in transition["exitCode"]:
                self.writeCode(code)
                
            for code in transition["triggerCode"]:
                self.writeCode(code)
            
            for code in transition["enterCode"]:
                self.writeCode(code)
            
            
            self.fOut.write("currentState = " + transition["destinationState"] + ";")
            
            self.fOut.dedent()
            self.fOut.write("}")
            self.fOut.write()
            