from ATOM3 import ATOM3
import os
from Tkinter import *
import DChartFunctions_java
import FileWriter_java

reload(DChartFunctions_java)
reload(FileWriter_java)

# Scans all lines of text and converts any event generation command (ie GEN(e))
# to the apropriate code. Also prefixes each line with 4*(indent) spaces. The
# resulting text is written to f, a file that has been opened for writing.
##def toFile(text, indent, f):
##    if text:
##        code=""
##        s=text.splitlines()
##    for l in s:
##        if l.startswith('GEN('):
##            event=l[4:-1]
##            l="EVENTQ.append('"+event+"')"
##            code=code+ 4*indent*" " + l + "\n"
##    f.write(code)

##def sameOperations(op1, op2):
##    return op1.replace(' ','') == op2.replace(' ','')
    

def gen(existingATOM3, CDmodel):

    init = "(self, dispatcher):"
            
    for classEntity in CDmodel.listNodes['CD_Class3']:

        fw = FileWriter_java.FileWriter(classEntity.name.getValue() +'.java')   # output file
        DChartFunctions_java.setFileWriter(fw)

        fw.write("import java.io.*;")
            
        dchartFound = False
        opbodies = {}
        opnames = []
        functionList = []
                
        fw.write("\n\nclass " + classEntity.name.getValue() + " extends Atom3Chart { ")
        fw.indent()

        constructorArg = ""
        constructorBody = ""
            
        for a in classEntity.attributes.getValue():
            atype = a.seltype
            
            classAttributeType = ""
            classAttributeInit = ""
            
            if atype=="Text": #text means operation yo
                #if a.name.getValue().strip=="__init__":
                #    init = a.initialValue.getValue().strip()
                #    continue
                #op = nowhites(a.name.getValue())
                #name = op[:op.index('(')]
                #args = op[op.index('('):]
                #if not name in opnames:
                #    opnames.append(name)
                #    opbodies[op]=a.initialValue.getValue()
                #else:
                #    print "WARNING - Multiple declaration of operation " + name
                #    print "Disregarding declaration " + op
                functionList.append(a.initialValue.getValue());
                    
            elif atype=="CDV3_DChart_TYPE":
                if not dchartFound:
                    pathString = a.initialValue.getValue()
                    if(not os.path.exists(pathString)):
                        print 'Path to dchart:',pathString,"not found."
                    else:
                        try:
                            print 'attempting a new atom3 instance'
                            temporaryWindow = Toplevel(existingATOM3.parent)
                            temporaryWindow.withdraw()
                            atom3i=ATOM3(temporaryWindow,"DCharts",0,1)
                            atom3i.open(fileName=pathString)
                            model = atom3i.ASGroot
                            DChartFunctions_java.load(model)
                            dchartFound = True
                        except:
                            print "An error occured while attempting to load dchart model"
                            temporaryWindow.destroy()
            elif atype=="Integer":
                #argument = a.self.seltype + " " + a.attrName + " = " + a.initialValue.toString() + ";"
                classAttributeType = "int";
                classAttributeInit = a.initialValue.toString();
                
            elif atype=="Float":
                classAttributeType = "float";
                classAttributeInit = a.initialValue.toString();
                
            elif atype=="String":
                #classAttributeType = "String";
                classAttributeType = a.initialValue.toString();
                
                
            if classAttributeType != "":
                
                # Declare the attributes
                fw.write("public " + classAttributeType + " " + a.attrName + ";")

                if classAttributeInit == "":
                    # Prepare the constructor function header for stuff without init values
                    if constructorArg == "" :
                        constructorArg = classAttributeType + " arg_" + a.attrName
                    else :
                        constructorArg = constructorArg + ", arg_" + classAttributeType + " " + a.attrName
                    # and prepare the constructor body                
                    constructorBody = constructorBody + "\n" + a.attrName + " = arg_" + a.attrName + ";"                    
                else:
                    #Attributes with initial values should just be initialized.
                    constructorBody = constructorBody + "\n" + a.attrName + " = " + classAttributeInit + ";"                    

        fw.write("\n")
        if dchartFound:
            DChartFunctions_java.writeStates()
            fw.write("\n")        
            fw.write("State currentState;")
            fw.write("\n")        
                
        # Constructor
        fw.write("public " + classEntity.name.getValue() + "(" + constructorArg + ") {")
        fw.indent()
        
        fw.write(constructorBody + "\n")                
        
        fw.write("int currentTime;")
        fw.write("currentTime = 0;")            
        
        #fw.write("\nfor(int i = 0; i < 10; i++) {")
        #fw.indent()        
        #fw.write("timers[i] = INFINITY;")
        
        DChartFunctions_java.setTriggeredOperations(opnames)
        
        if dchartFound:
            DChartFunctions_java.writeInitCode()
            
        fw.dedent()        
        fw.write("}")
        
        # Process function
        if dchartFound:

            fw.write("\n public void process( ) {")
            fw.indent()
            DChartFunctions_java.writeEventProcessingCode('chartEventList')
            fw.dedent()                    
            fw.write("}")

        #for op in opbodies.keys():
        #    body = strip(opbodies[op])
        #    fw.write("\ndef " + op + body)
        #    fw.indent()
        #    if dchartfound:
        #        DChartFunctions_java.writeTriggeredOperationCode(op)
        #    fw.dedent()
            for b in functionList:
                fw.write("\n" + b);
            
        if dchartFound:
            temporaryWindow.destroy()
            dchartFound = False                
        
    fw.close()
    
